class schematf::service(
  $service_ensure = $schematf::service_ensure,
  $service_manage = $schematf::service_manage,
  $service_name   = $schematf::service_name,
  $manage_ssl_proxy = $schematf::manage_ssl_proxy,
  $server_port    = $schematf::server_port,
  $raw_domain     = $schematf::raw_domain,
) inherits schematf {

  require jdk_oracle
  
  if !defined(Class['nginx']) {
    class { 'nginx': }
  }
  
  
  if ($manage_ssl_proxy) {
    nginx::resource::vhost { 'schema.tf':
      proxy => "http://127.0.0.1:${server_port}",
      rewrite_to_https => true,
      index_files => [],
      listen_port => 80,
      ssl_cert => "/etc/letsencrypt/live/${raw_domain}/fullchain.pem",
      ssl_key => "/etc/letsencrypt/live/${raw_domain}/privkey.pem",
      ssl => true,
      ssl_port => 443
    }
  }
  
  validate_re($service_ensure, '^(running|stopped)$')
  validate_bool($service_manage)

  if ($service_manage) {
    if $service_ensure == 'running' {
      $ensure_real = 'running'
      $enable_real = true
    } else {
      $ensure_real = 'stopped'
      $enable_real = false
    }

    service { 'schematf':
      ensure     => $ensure_real,
      enable     => $enable_real,
      hasstatus  => true,
      hasrestart => true,
      name       => $service_name,
	    require    => Package['schematf']
    }
  }

}